unsigned int CheckSum(unsigned int xdata *check,unsigned int length)
{
	unsigned long sum = 0;
	unsigned int i;

	for (i=0;i<(length)/2;i++)
	{
		sum += *check++;
	}
	if(length & 0x01)
	{
		sum = sum + ((*check)&0xff00);
	}
	sum = (sum&0xffff) + ((sum>>16)&0xffff);
	if(sum & 0xffff0000)
	{
		sum++;
	}
	
	return ((unsigned int)(~((sum)&0xffff)));
}

unsigned char VerifyIpHeadCrc()
{
	unsigned int crc;

	crc = CheckSum(&RxdNetBuff.IpPacket.IpPacket[0],(RxdNetBuff.IpFrame.VerandIphLen&0x0f)*4);
	if(crc == 0)
	{
		return (1);
	}
	return(0);
}

unsigned char VerifyTcpCrc()
{
	unsigned int crc;

	RxdNetBuff.IpFrame.ttl=0;
	RxdNetBuff.IpFrame.Crc=RxdNetBuff.IpFrame.TotalLen-(RxdNetBuff.IpFrame.VerandIphLen&0x0f)*4;
	crc = CheckSum(&RxdNetBuff.IpPacket.IpPacket[4],RxdNetBuff.IpFrame.Crc+12);
	if(crc == 0)
	{
		return (1);
	}
	return(0);
}


uint CreateIpHeadCrc()
{
	uchar i;

	CrcTemp.dwords = 0;
	for(i=9;i<19;i++)
	{
		CrcTemp.dwords = CrcTemp.dwords + TxdNetBuff.words.wordbuf[i];
	}
	while(CrcTemp.words.high>0) 
	{
		CrcTemp.dwords = (ulong)(CrcTemp.words.high + CrcTemp.words.low);
    }
	CrcTemp.words.low = 0xffff - CrcTemp.words.low;
	return(CrcTemp.words.low);
}

uint CreateIcmpCrc()
{
	uchar i;

	CrcTemp.dwords=0;
	for(i=19;i<39;i++)
	{
		CrcTemp.dwords = CrcTemp.dwords + TxdNetBuff.words.wordbuf[i];
	}
	while(CrcTemp.words.high>0) 
	{
		CrcTemp.dwords = (ulong)(CrcTemp.words.high+CrcTemp.words.low);
    }
	CrcTemp.words.low = 0xffff - CrcTemp.words.low;
	return(CrcTemp.words.low);
}

unsigned char  VerifyUdpCrc()
{
	unsigned int crc;

	RxdNetBuff.IpFrame.ttl = 0;
	RxdNetBuff.IpFrame.Crc = RxdNetBuff.IpFrame.TotalLen - (RxdNetBuff.IpFrame.VerandIphLen&0x0f)*4;
	crc = CheckSum(&RxdNetBuff.IpPacket.IpPacket[4],RxdNetBuff.IpFrame.Crc+12);
	if(crc==0)
	{
		return (1);
 	}
	return(0);
}

uint CreateTcpCrc()
{
	uint crc;

	crc = CheckSum(&TxdNetBuff.IpPacket.IpPacket[4],TxdNetBuff.IpFrame.Crc+12);
	return (crc);
}